
%if 0%{?fedora}
# Unavailable deps
# https://bugzilla.redhat.com/show_bug.cgi?id=1193730
%bcond_with jena
%endif

Name:          semweb4j
Version:       5.0.1
Release:       1%{?dist}
Summary:       Java RDF Library
License:       BSD
# http://semanticweb.org/wiki/Semweb4j
URL:           https://github.com/semweb4j/semweb4j
Source0:       https://github.com/semweb4j/semweb4j/archive/rootbuilder-%{version}.tar.gz

BuildRequires: maven-local
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(org.eclipse.osgi:org.eclipse.osgi)
BuildRequires: mvn(org.slf4j:slf4j-api)
BuildRequires: mvn(org.slf4j:slf4j-log4j12)
BuildRequires: mvn(org.sonatype.oss:oss-parent:pom:)
BuildRequires: mvn(com.fasterxml.jackson.core:jackson-core)
BuildRequires: mvn(com.github.jsonld-java:jsonld-java-tools)
BuildRequires: mvn(commons-io:commons-io)
BuildRequires: mvn(org.apache.maven:maven-plugin-api)
BuildRequires: mvn(org.apache.maven:maven-project)
BuildRequires: mvn(org.apache.maven.plugin-testing:maven-plugin-testing-harness)
BuildRequires: mvn(org.apache.maven.plugins:maven-plugin-plugin)
BuildRequires: mvn(org.openrdf.sesame:sesame-bom:pom:)
BuildRequires: mvn(org.openrdf.sesame:sesame-repository-http)
BuildRequires: mvn(org.openrdf.sesame:sesame-repository-sail)
BuildRequires: mvn(org.openrdf.sesame:sesame-rio-n3)
BuildRequires: mvn(org.openrdf.sesame:sesame-rio-rdfjson)
BuildRequires: mvn(org.openrdf.sesame:sesame-rio-rdfxml)
BuildRequires: mvn(org.openrdf.sesame:sesame-rio-trig)
BuildRequires: mvn(org.openrdf.sesame:sesame-runtime-osgi)
BuildRequires: mvn(org.openrdf.sesame:sesame-sail-memory)
BuildRequires: mvn(log4j:log4j:1.2.17)
%if %{with jena}
BuildRequires: mvn(org.apache.jena:jena-arq)
%endif
BuildRequires: mvn(velocity:velocity)
BuildRequires: mvn(xerces:xercesImpl)

BuildArch:     noarch

%description
The Semweb4j project gives you simple libraries to do
complicated things with Java and RDF. Very little
semantic web knowledge is required.

This package provides Semweb4j RDF2Go API. RDF2go
is an implementation-independent Java API with the design
goals: portability (hence the name), performance and
ease of implementation.

%package bom
Summary:       Semweb4j bill of materials (BOM) POM

%description bom
Semweb4j bill of materials (BOM) POM.

%package dist
Summary:       Semweb4j distribution POM

%description dist
Semweb4j distribution POM.

%package parent
Summary:       Semweb4j Parent POM

%description parent
This is a parent maven POM which models common settings in
semweb4j.org projects.

%package rdf2go-dist
Summary:       Semweb4j RDF2Go distribution Parent POM

%description rdf2go-dist
This project simply bundles all RDF2Go parts in a single
distribution - by listing all other parts as dependencies.
This includes all transitive dependencies too.

%package rdf2go-impl-sesame
Summary:       Semweb4j RDF2Go Sesame implementation
# AFL-3.0: org.semweb4j.rdf2go.impl.sesame/src/main/java/org/openrdf/rdf2go/osgi/Activator.java
License:       BSD and AFL

%description rdf2go-impl-sesame
RDF2Go driver for OpenRDF Sesame.

%package rdfreactor-dist
Summary:       Semweb4j RDFReactor distribution Parent POM

%description rdfreactor-dist
This project simply bundles all RDFReactor parts in a single
distribution - by listing all other parts as dependencies.
This includes all transitive dependencies too.

%package rdfreactor-generator
Summary:       Semweb4j RDFReactor code generator

%description rdfreactor-generator
RDFReactor creates domain-specific, type-safe Java classes which
act as a view over domain-free, loosely typed RDF instances.
This package generates the Java classes form an RDF vocabulary.

%package rdfreactor-runtime
Summary:       Semweb4j RDFReactor runtime library

%description rdfreactor-runtime
RDFReactor creates domain-specific, type-safe Java classes which
act as a view over domain-free, loosely typed RDF instances.
This library needs to be shipped together with generated classes.

%package rdfreactor-maven-plugin
Summary:       Semweb4j RDFReactor code generator Maven Mojo

%description rdfreactor-maven-plugin
A Maven plugin that uses RDFReactor to
generate Java code from an RDF Schema.

%package root
Summary:       Semweb4j root builder POM

%description root
Semweb4j root builder POM.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}-rootbuilder-%{version}
# Cleanup
find . -name "*.class" -delete
find . -name "*.jar" -print -delete

%pom_remove_plugin -r :maven-assembly-plugin
%pom_remove_plugin -r :maven-source-plugin
%pom_remove_plugin -r :maven-doap-plugin
%pom_remove_plugin -r :cobertura-maven-plugin
%pom_remove_plugin -r :maven-javadoc-plugin
%pom_remove_plugin -r :maven-site-plugin
%pom_remove_plugin -r :maven-deploy-plugin

%pom_disable_module ../org.semweb4j.skin org.semweb4j.dist

# Use jsonld-java 0.3 adapt for newer 0.7.0 release
%pom_change_dep :jsonld-java-sesame :jsonld-java-tools:0.7.0 org.semweb4j.rdf2go.impl.sesame
# package org.openrdf.repository.http does not exist
%pom_add_dep org.openrdf.sesame:sesame-repository-http:2.8.7 org.semweb4j.rdf2go.impl.sesame
# package org.openrdf.repository.sail does not exist
%pom_add_dep org.openrdf.sesame:sesame-repository-sail:2.8.7 org.semweb4j.rdf2go.impl.sesame
# Provider org.openrdf.rio.n3.N3ParserFactory not found
%pom_add_dep org.openrdf.sesame:sesame-rio-n3:2.8.7:test org.semweb4j.rdf2go.impl.sesame
%pom_add_dep org.openrdf.sesame:sesame-rio-n3:2.8.7:test org.semweb4j.rdfreactor.generator

%pom_change_dep :log4j :log4j:1.2.17 org.semweb4j.rdfreactor.generator
%pom_change_dep :log4j :log4j:1.2.17 org.semweb4j.rdfreactor.rdfreactor-maven-plugin

%if %{without jena}
# Use com.github.jsonld-java:jsonld-java-jena:0.4.1
# NOTE JSONLD-Java integration is provided natively by Jena since 2.11.2
%pom_disable_module ../org.semweb4j.rdf2go.impl.jena org.semweb4j.rdf2go.dist
%pom_xpath_remove "pom:build/pom:extensions" org.semweb4j.rdf2go.impl.jena
%pom_remove_dep :rdf2go.impl.jena org.semweb4j.rdf2go.dist
%endif

%pom_change_dep -r :org.eclipse.osgi org.eclipse.osgi:

cp -p org.semweb4j.rdf2go.impl.sesame/LICENSE.txt .

# Convert from dos to unix line ending
sed -i.orig 's/\r//' org.semweb4j.rdf2go.impl.sesame/README.txt
touch -r org.semweb4j.rdf2go.impl.sesame/README.txt.orig org.semweb4j.rdf2go.impl.sesame/README.txt
rm org.semweb4j.rdf2go.impl.sesame/README.txt.orig

# AssertionFailedError: expected:<Test2^^http://www.w3.org/2001/XMLSchema#string> but was:<Test2>
rm -r org.semweb4j.rdf2go.impl.sesame/src/test/java/org/openrdf/rdf2go/RepositoryModelTest.java
#  RepositoryModelSetTest>AbstractModelSetTest.testAddModel:209 expected:<2> but was:<1>
#  RepositoryModelSetTest>AbstractModelSetTest.testDeleteStatement:343 expected:<2> but was:<1>
rm -r org.semweb4j.rdf2go.impl.sesame/src/test/java/org/openrdf/rdf2go/RepositoryModelSetTest.java

# RDFDataException: Cannot convert from datatype http://www.w3.org/2001/XMLSchema#string to URI
rm -r org.semweb4j.rdfreactor.generator/src/test/java/org/ontoware/rdfreactor/generator/TestReportedBugs.java

%build

%mvn_build -s

%install
%mvn_install

%files -f .mfiles-rdf2go.api
%doc org.semweb4j.rdf2go.api/README.txt
%license LICENSE.txt

%files bom -f .mfiles-bom
%files dist -f .mfiles-dist
%files parent -f .mfiles-parent
%files rdf2go-dist -f .mfiles-rdf2go.dist
%files root -f .mfiles-rootbuilder

%files rdf2go-impl-sesame -f .mfiles-rdf2go.impl.sesame
%doc org.semweb4j.rdf2go.impl.sesame/README.txt
%license org.semweb4j.rdf2go.impl.sesame/LICENSE.txt
%files rdfreactor-dist -f .mfiles-rdfreactor.dist
%files rdfreactor-generator -f .mfiles-rdfreactor.generator
%files rdfreactor-runtime -f .mfiles-rdfreactor.runtime
%files rdfreactor-maven-plugin -f .mfiles-rdfreactor-maven-plugin

%files javadoc -f .mfiles-javadoc
%license LICENSE.txt

%changelog
* Thu Jun 25 2015 gil cattaneo <puntogil@libero.it> 5.0.1-1
- initial rpm
